
**Hashdown**在线工具可以将文本编码成特殊的格式

编码网址：
[hashdown.github.io/edit.html](https://hashdown.github.io/edit.html)

下载离线版： [github.com/rinick/hashdown/archive/gh-pages.zip](https://github.com/rinick/hashdown/archive/gh-pages.zip)

支持五种编码模式

| 编码方式 | 特点 | 输出示例 |
| ------------- | ------------- | ------------- |
| 天书点阵 | 编码到二进制点阵 | ⡯⡯⡯⠺⡢⡣⡣⡤⡳⡣⡭⡭⠺⡩⡻⡳ |
| 链接 | 点开直接显示 | [https://hashdown.github.io/#GMgIv-_0GTC7iTBH4gyek93I](https://hashdown.github.io/#GMgIv-_0GTC7iTBH4gyek93I) |
| Base2e15 | 输出字符最少 | 炅땯腖귻㟫䩍븀묓歊 |
| 蝌蚪码 | 什么鬼？ | /ًًٍٍٍٍََََُُُِِِّّّّّّّّّْْْْْْْْْْْْٕ۪۪۪ٓۤ۠ۤ۠ﾞ |
| 隐形码 | 完全隐藏内容 | 编码以后的字符⁪‌​⁭‍⁬⁫⁬⁪⁫​⁭⁭⁬⁫⁬⁪⁫⁭⁮‌⁫不可见 |

## 天书点阵

将字符转换成二进制并以布莱叶码的方式显示，图形中的每一个点对应数据中的每一比特

比特编码表：

|0x01|0x02|0x04|0x08|0x10|0x20|0x40|0x80|
|:--:|:--:|:--:|:--:|:--:|:--:|:--:|:--:|
|`⠁`|`⠈`|`⠂`|`⠐`|`⠄`|`⠠`|`⡀`|`⢀`|


## Hashdown链接

Hashdown链接把文本以哈希的方式转换到Url中，以下特性使它有独特的安全性

* 编解码完全在客户端完成，服务器永远都不知道用户编码了哪些内容. 链接的哈希(Url中#之后的部分)不会被发送到网络中。
* 即使服务器下线或被屏蔽，你的内容也不会丢失，只要能找到任何Hashdown的镜像网站，或者离线版的Hashdown工具，内容仍可以被还原。
* Hashdown支持密码加密。

## Base2e15

[Base2e15](https://github.com/rinick/base2e15)将文本转换成Unicode字符，每个字符存储15比特数据

再加上Hashdown本身支持压缩，这能在有限的字符里存储更多的数据

## 蝌蚪码

蝌蚪码通过Unicode中特殊的组合字符把许多字符显示在一个字符的空间，类似蝌蚪的形状。

手机系统上可能无法在编辑框看到正确的字体，但发送到短信，微信，微博时可以正常显示



## 隐形码

隐藏文字将数据转换到ACSII的控制字符，这些字符在大多数浏览器里都不可见

样本数据，输入数据中需要隐藏的部分用大括号{}区分开。 否则全部数据会被隐藏

|  | 输入 | 输出 |
| ------------- | ------------- | ------------- |
| 使用{} | 你好{隐形文本}世界 | 你好⁪​‌‍‍⁪⁪‌⁮⁬⁮⁮⁮⁪⁫⁪⁪⁭‍⁮‍⁭⁬‌⁭‍‍世界 |
| 不使用{} | 全部隐藏 | >⁮‍⁪‌⁬‍‍​⁮‌⁪⁪⁭⁭⁫‍⁮‌⁬‌⁪‍​⁮⁮‌⁬‌⁭‍⁬⁫< |

如果输入文本没有大括号，那么输出文本将完全不可见，为了方便复制，输出框会在隐形文本的前后加上`><`

隐形码编码效率低，只适加密较短的字符串。


## 镜像网址
* [https://rinick.github.io/hashdown](https://rinick.github.io/hashdown)
* [http://2e15.com](http://2e15.com)